import { Injectable } from '@angular/core';
import { Observable, of } from 'rxjs';
import { Assignment } from '../assignments/assignment.model';
import { LoggingService } from './logging.service';

@Injectable({
  providedIn: 'root'
})

export class AssignmentsService {
  assignments:Assignment[] = [
    {
      id:1,
      nom: 'Devoir WebComponents lecteur video',
      dateDeRendu: new Date('2021-11-07'),
      rendu: true,
    },
    {
      id:2,
      nom: 'Devoir Angular en binôme',
      dateDeRendu: new Date('2021-12-18'),
      rendu: false,
    },
    {
      id:3,
      nom: 'Devoir App Mobile cross platform',
      dateDeRendu: new Date('2021-12-03'),
      rendu: false,
    },
  ];

  constructor(private loggingService:LoggingService) { }

  getAssignments():Observable<Assignment[]> {
    return of(this.assignments);
  }

  getAssignment(id:number):Observable<Assignment|undefined> {
    let assignment = this.assignments.find(elem => elem.id === id);

    return of(assignment);
  }

  addAssignment(assignment:Assignment):Observable<string>{
    this.assignments.push(assignment);

    this.loggingService.log(assignment.nom, "ajouté");

    return of(`Assignment ${assignment.nom} ajouté`);
  }

  updateAssignment(assignment:Assignment):Observable<string> {
    // pour le moment rien de spécial à faire
    // mais plus tard -> requête PUT sur un web service
    // pour mettre à jour une BD distante...

    return of(`Assignment ${assignment.nom} modifié`);
  }

  deleteAssignment(assignment:Assignment):Observable<string> {

    const pos = this.assignments.indexOf(assignment);
    this.assignments.splice(pos, 1);

    return of(`Assignment ${assignment.nom} supprimé`);
  }
}
